Name:		truezip
Version:	7.6.6
Release:	11%{?dist}
Summary:	Java based VFS for treating archive files as virtual directories

Group:		Development/Libraries
License:	EPL
URL:		http://truezip.java.net/

# hg clone https://hg.java.net/hg/truezip~v7 && cd truezip~v7/
# hg archive -r truezip-7.5.5 truezip-7.5.5.tar.gz -X ".hg*"
Source0:	%{name}-%{version}.tar.gz
Source1:	http://www.eclipse.org/legal/epl-v10.html


BuildArch:	noarch

BuildRequires:	apache-commons-compress
BuildRequires:	bouncycastle
BuildRequires:	findbugs
BuildRequires:	jemmy
BuildRequires:	jsr-305
BuildRequires:	junit
BuildRequires:	maven-local
BuildRequires:	schlichtherle-oss-parent

BuildRequires:	maven-antrun-plugin
BuildRequires:	maven-archetype-common
BuildRequires:	maven-archetype-packaging
BuildRequires:	maven-archetype-plugin
BuildRequires:	maven-compiler-plugin
BuildRequires:	maven-enforcer-plugin
BuildRequires:	maven-failsafe-plugin
BuildRequires:	maven-install-plugin
BuildRequires:	maven-jar-plugin
BuildRequires:	maven-javadoc-plugin
BuildRequires:	maven-plugin-jxr
BuildRequires:	maven-plugin-cobertura
BuildRequires:	maven-release-plugin
BuildRequires:	maven-resources-plugin
BuildRequires:	maven-site-plugin
BuildRequires:	maven-surefire-plugin

Requires:	%{name}-driver-parent = %{version}-%{release}
Requires:	%{name}-driver-file = %{version}-%{release}
Requires:	%{name}-driver-http = %{version}-%{release}
Requires:	%{name}-driver-tar = %{version}-%{release}
Requires:	%{name}-driver-tzp = %{version}-%{release}
Requires:	%{name}-driver-zip = %{version}-%{release}
Requires:	%{name}-extension-parent = %{version}-%{release}
Requires:	%{name}-extension-jmx-jul = %{version}-%{release}
Requires:	%{name}-extension-pace = %{version}-%{release}
Requires:	%{name}-file = %{version}-%{release}
Requires:	%{name}-kernel = %{version}-%{release}
Requires:	%{name}-path = %{version}-%{release}
Requires:	%{name}-samples = %{version}-%{release}
Requires:	%{name}-swing = %{version}-%{release}

%description
TrueVFS is a Java based virtual file system (VFS) which enables
client applications to perform CRUD (Create, Read, Update, Delete)
operations on archive files as if they were virtual directories,
even with nested archive files in multithreaded environments.

As a library, TrueVFS provides simple, uniform, transparent,
thread-safe, read/write access to archive files as if they were
virtual directories in a file system path.

As a framework, TrueVFS provides the interfaces and classes to
write file system drivers which plug-in to its federated file
system space.

%package parent
Summary:	Parent POM for TrueZip modules
Requires:	schlichtherle-oss-parent

%description parent
Parent POM for TrueZip modules.

%package driver-parent
Summary:	Parent POM for TrueZip pluggable file system drivers

%description driver-parent
Parent POM for TrueZip pluggable file system drivers.

%package driver-file
Summary:	TrueZip driver for the FILE scheme

%description driver-file
The file system driver family for the FILE scheme.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-http
Summary:	TrueZip driver for the HTTP(S) scheme

%description driver-http
The file system driver for the HTTP(S) scheme.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-tar
Summary:	TrueZip driver for TAR archives

%description driver-tar
The file system driver family for TAR and related archive file types.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-tzp
Summary:	TrueZip driver for ZIP.RAES (TZP) encrypted archives

%description driver-tzp
The file system driver family for RAES encrypted ZIP alias
ZIP.RAES alias TZP files.

Add the JAR artifact of this module to the run time class path to
make its file system drivers available for service location in the
client API modules.

%package driver-zip
Summary:	TrueZip driver for ZIP archives

%description driver-zip
TrueZIP Path module application - requires JSE 7.

%package extension-parent
Summary:	Parent POM for TrueZip pluggable extensions

%description extension-parent
Parent POM for TrueZip pluggable extensions.

%package extension-jmx-jul
Summary:	TrueZip JMX/JUL Extension

%description extension-jmx-jul
This module provides a file system manager and an I/O pool service
for managing and monitoring TrueZIP via JMX and java.util.logging.

Add the JAR artifact of this module to the run time class path to
make its file system manager and I/O pool service available for
service location in the client API modules.

%package extension-pace
Summary:	TrueZip PaceManager Extension

%description extension-pace
This module constrains the number of mounted archive files in order to
save some heap space. It provides a JMX interface for monitoring and
management. Add the JAR artifact of this module to the run time class
path to make its services available for service location in the client
API modules.

%package file
Summary:	TrueZip File*

%description file
This module provides the TFile* classes for simple, uniform,
transparent, thread-safe, read/write access to archive files
as if they were virtual directories in a file system path.

This module also provides Swing GUI classes for viewing file
trees and choosing entries in archive files.

%package kernel
Summary:	Implements and manages virtual file systems for %{name}


%description kernel
This module implements virtual file systems from arbitrary resources,
manages their state and commits unsynchronized changes if required or
requested.

The TrueZIP Kernel uses file system drivers to access these resources.
It provides multithreading, multiplexing, caching and buffering so that
the file system drivers do not need to take care of this.

%package path
Summary:	TrueZip Path

%description path
This module provides the TPath class for simple, uniform,
transparent, thread-safe, read/write access to archive
files as if they were virtual directories in a file system path.
It also provides the TFileSystemProvider class to implement a file
system provider for the NIO.2 API (JSR 203) in JSE 7.

%package samples
Summary:	TrueZip Samples

%description samples
Sample applications to demonstrate the usage of various TrueZIP module
APIs.

Some of these samples use rather advanced or exotic features which
makes them more complex than necessary for a typical application.

By design, the sample applications use all file system drivers which
can be located at runtime.
Location of the available file system drivers is performed by
scanning the class path - see the Javaodoc for the TrueZIP Kernel class
de.schlichtherle.truezip.fs.sl.FsDriverLocator for more information.

%package swing
Summary:	TrueZip general Swing GUI classes

%description swing
General Swing GUI classes.

This module does not depend on other TrueZIP modules.

%package javadoc
Summary:	Javadocs for %{name}
Group:		Documentation

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q

find -type f -name *.zip -delete
find -type f -name *.jar -delete
find -type f -name *.class -delete

# Fix findbugs groupId (switch for new dep)
%pom_remove_dep com.google.code.findbugs:annotations

# Add jsr-305 as dependency for javax.annotation.concurrent
%pom_add_dep org.jsr-305:ri

%pom_disable_module %{name}-archetype

pushd truezip-driver/truezip-driver-tar/src/main/java/de/schlichtherle/truezip/fs/archive/tar/
	sed -i 's/DEFAULT_RCDSIZE/TarDriver.DEFAULT_RCDSIZE/g' TarInputShop.java
	sed -i 's/DEFAULT_BLKSIZE/TarDriver.DEFAULT_BLKSIZE/g' TarInputShop.java
popd


# ${project.groupId} doesn't seem to get expanded properly here
%pom_remove_dep :%{name}-kernel %{name}-extension
%pom_add_dep de.schlichtherle.%{name}:%{name}-kernel:%{version} %{name}-extension
%pom_remove_dep :%{name}-kernel %{name}-driver
%pom_add_dep de.schlichtherle.%{name}:%{name}-kernel:%{version} %{name}-driver
find -name pom.xml -exec \
	sed -i -e "s/\${project.groupId}/de.schlichtherle.truezip/g" -e "s/\${project.version}/%{version}/g" {} \;

%build
# Skipping tests because some fail with 'Bad test setup' error
%mvn_build -s --skip-tests

%install
%mvn_install

%files parent -f .mfiles-%{name}
%files javadoc -f .mfiles-javadoc
%files driver-parent -f .mfiles-%{name}-driver
%files driver-file -f .mfiles-%{name}-driver-file
%files driver-http -f .mfiles-%{name}-driver-http
%files driver-tar -f .mfiles-%{name}-driver-tar
%files driver-tzp -f .mfiles-%{name}-driver-tzp
%files driver-zip -f .mfiles-%{name}-driver-zip
%files extension-parent -f .mfiles-%{name}-extension
%files extension-jmx-jul -f .mfiles-%{name}-extension-jmx-jul
%files extension-pace -f .mfiles-%{name}-extension-pace
%files file -f .mfiles-%{name}-file
%files kernel -f .mfiles-%{name}-kernel
%files path -f .mfiles-%{name}-path
%files samples -f .mfiles-%{name}-samples
%files swing -f .mfiles-%{name}-swing

%changelog
* Fri Nov 15 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.6.6-11
- Fix colliding constants problem (DEFAULT_RCDSIZE/DEFAULT_BLKSIZE)
- Replace pom variables that don't expand

* Fri Nov 15 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.6.6-8
- Rebuild in f20

* Fri Nov 08 2013 Marek Goldmann <mgoldman@redhat.com> - 7.6.6-7
- Rebuild after change in bouncycastle

* Thu Oct 24 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.6.6-6
- Use correct parent now that it's available
- Remove unnecessary pom_add_dep invocation

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.6.6-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Apr 16 2013 Gerard Ryan <galileo@fedoraproject.org> - 7.6.6-4
- Use new maven macros.

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.6.6-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 7.6.6-2
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Sat Oct 13  2012 Gerard Ryan <galileo@fedoraproject.org> - 7.6.6-1
- Update to upstream 7.6.6.
- Remove patch and add pom macros instead.
- add new PaceManager extension as a subpackage.
- Switch parent in POM to older parent from 7.5.5.

* Tue Jul 24 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-6
- Add schlichtherle-oss-parent as a requires for truezip-parent

* Tue Jul 24 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-5
- Add -parent subpackage, as main pom seems needed for maven

* Mon Jul 23 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-4
- Fix spelling errors; Add license file to srpm.

* Tue Jul 17 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-3
- Put jar files into a sub-directory of javadir
- Add -f flag to add_maven_depmap macro calls
- correctly name POM files
- Add release requirement to versioned dependencies
- Remove unnecessary group field from subpackages

* Fri Jul 13 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-2
- Add additional maven requirements to BR.

* Fri Jun 29 2012 Gerard Ryan <galileo@fedoraproject.org> - 7.5.5-1
- Initial package.
